﻿#ifndef DOORS_H
#define DOORS_H

#include "../common/sources/Map.h"
#include "walls.h"

#define DOOR_ANIMATION_TIME 90
#define DOOR_POS_FACTOR     50

#define DOOR_ORNATE_ARCHED  10

struct SDoorElem
{
    char    file[32];           // nom de fichier
    int16_t x, y;               // position
    int16_t cx1, cy1, cx2, cy2; // rectangle de clipping
};

class CDoors
{
public:
    CDoors();
    bool    isFacing(CTile* tile);
    void    draw(QImage* image, CVec2 mapPos, CVec2 tablePos);
    void    readDoorsDB();
    void    readDoorOrnatesDB();
    bool    isOpened(CTile* tile);
    void    update();

private:
    struct CDoorData
    {
        QString files[3];
    };

    struct CDoorOrnateData
    {
        QString file;
        CVec2   pos;
    };

    void    drawFrameElement(QImage* image, CVec2 tablePos, SDoorElem table[WALL_TABLE_HEIGHT][WALL_TABLE_WIDTH], bool isFlipped);
    void    drawDoor(QImage* image, CVec2 tablePos, CTile *tile);
    void    clipToMainView(QRect* clip);

    std::vector<CDoorData>          doorsDatas;
    std::vector<CDoorOrnateData>    doorOrnatesDatas;
};

extern CDoors   doors;

#endif // DOORS_H
